// Данный пример плавно меняет аналоговый уровень на выводе модуля. // * Строки со звёздочкой являются необязательными.
                                                                    //
#include "../iarduino_I2C_Expander.h"                               //   Подключаем библиотеку для работы с расширителем выводов.
iarduino_I2C_Expander gpio(0x08);                                   //   Объявляем объект gpio для работы с функциями и методами библиотеки iarduino_I2C_Expander, указывая адрес модуля на шине I2C.
                                                                    //   Если объявить объект без указания адреса (iarduino_I2C_Expander gpio;), то адрес будет найден автоматически.
double val = 2;                                                     //   Определяем начальное аналоговое значение.
bool   flg = 1;                                                     //   Определяем флаг приращения аналогового значения (0-убывает, 1-растёт).
                                                                    //
void loop(void);

int main(){                                                         //
    delay(500);                                                     // * Ждём завершение переходных процессов связанных с подачей питания.
//  Готовим модуль к работе:                                        //
    gpio.begin();                                                   //   Инициируем работу с расширителем выводов.
    gpio.pinMode(3, OUTPUT, ANALOG);                                // * Конфигурируем вывод 3 на работу в качестве аналогового выхода.
    loop();
}                                                                   //
                                                                    //
void loop(){                                                        //
  while(1){
    delay(10);                                                      //   Чем выше задержка, тем плавнее меняется аналоговый уровень.
    if(flg      ){val*=1.05;}else{val/=1.05;}                       //   Увеличиваем или уменьшаем аналоговое значение.
    if(val<=2   ){val = 2;    flg=1;}                               //   Меняем спад аналогового уровня на рост.
    if(val>=4095){val = 4095; flg=0;}                               //   Меняем рост аналогового уровня на спад.
                                                                    //
    gpio.analogWrite(3, val);                                       //   Устанавливаем на 3 выводе уровень равный значению «val».
  }
}                                                                   //   Допустимые значения - от 0 до 4095.
                                                                    //
//  ПРИМЕЧАНИЕ:                                                     //
//  Для проверки работы скетча подключите светодиод к 3 выводу.     //
//  Модуль имитирует аналоговый сигнал используя ШИМ.               //
//  Сигнал ШИМ поддерживают только выводы 0,1,2,3.                  //
//  Для выводов 4,5,6,7, установка уровня от 0 до 2047 приведёт к   //
//  появлению логического 0, а установка уровня от 2048 до 4095 к   //
//  появлению логической 1.                                         //

