// Данный пример читает логический уровень с вывода модуля.         // * Строки со звёздочкой являются необязательными.
                                                                    //
#include <iostream>
#include <string>
#include "../iarduino_I2C_Expander.h"                               //   Подключаем библиотеку для работы с расширителем выводов.
iarduino_I2C_Expander gpio(0x08);                                   //   Объявляем объект gpio для работы с функциями и методами библиотеки iarduino_I2C_Expander, указывая адрес модуля на шине I2C.
                                                                    //   Если объявить объект без указания адреса (iarduino_I2C_Expander gpio;), то адрес будет найден автоматически.
void loop(void);

int main(){                                                         //
  delay(500);                                                       // * Ждём завершение переходных процессов связанных с подачей питания.
//Готовим модуль к работе:                                          //
  gpio.begin();                                                     //   Инициируем работу с расширителем выводов.
  gpio.pinMode(4, INPUT, DIGITAL);                                  // * Конфигурируем вывод 4 на работу в качестве цифрового входа.
  gpio.pinPull(4, PULL_DOWN);                                       // * Прижимаем вывод 4 к уровню GND через внутренний резистор.
  loop();
}                                                                   //
                                                                    //
void loop(){                                                        //
  while(1){
    bool pin4 = gpio.digitalRead(4);                                //   Читаем логический уровень с вывода №4 в переменную «pin4».
    std::cout << "Pin_4="+std::to_string(pin4) << '\n';             //
    delay(100);                                                     // * Ждём десятую долю секунды, чтоб не захламлять stdout.
  }
}                                                                   //
                                                                    //
//  ПРИМЕЧАНИЕ:                                                     //
//  Для проверки работы скетча подключите кнопку к 4 выводу и Vcc.  //
//  Если Вы желаете подключить кнопку не к Vcc, а к GND, то уровень //
//  4 вывода нужно не прижать к GND, а подтянуть до уровня Vcc.     //
//  Для этого укажите функции pinPull() не PULL_DOWN, а PULL_UP.    //
