// Данный пример подключает внутренние резисторы к выводам модуля.  // * Строки со звёздочкой являются необязательными.
                                                                    //
#include <iostream>                                                 // 
#include "../iarduino_I2C_Expander.h"                               //   Подключаем библиотеку для работы с расширителем выводов.
iarduino_I2C_Expander gpio(0x08);                                   //   Объявляем объект gpio для работы с функциями и методами библиотеки iarduino_I2C_Expander, указывая адрес модуля на шине I2C.
                                                                    // 
void loop(void);                                                    // 
                                                                    //   Если объявить объект без указания адреса (iarduino_I2C_Expander gpio;), то адрес будет найден автоматически.
int main(){                                                       //
//Готовим модуль к работе:                                          //
  gpio.begin();                                                     //   Инициируем работу с расширителем выводов.
//  gpio.changeBus("/dev/i2c-1");
  gpio.pinMode(5, INPUT, DIGITAL);                                  // * Конфигурируем вывод 5 на работу в качестве цифрового входа.
  gpio.pinMode(6, INPUT, DIGITAL);                                  // * Конфигурируем вывод 6 на работу в качестве цифрового входа.
  gpio.pinMode(7, INPUT, DIGITAL);                                  // * Конфигурируем вывод 7 на работу в качестве цифрового входа.
  gpio.pinPull(5, PULL_DOWN);                                       //   Прижимаем   вывод 5 к  уровню GND через внутренний резистор.
  gpio.pinPull(6, PULL_UP);                                         //   Подтягиваем вывод 6 до уровня VCC через внутренний резистор.
  gpio.pinPull(7, PULL_NO);                                         //   Оставляем   вывод 7 без подключения внутренних резисторов.
  loop();                                                           // 
}                                                                   //
                                                                    //
void loop(){                                                        //
  while(1){
    bool pin5 = gpio.digitalRead(5);                                //   Читаем логический уровень с вывода №5 в переменную «pin5».
    bool pin6 = gpio.digitalRead(6);                                //   Читаем логический уровень с вывода №6 в переменную «pin6».
    bool pin7 = gpio.digitalRead(7);                                //   Читаем логический уровень с вывода №7 в переменную «pin7».
    std::cout << "p5="<< int(pin5)<<", p6="<<int(pin6)<<", p7="<<int(pin7) << '\n';   //
    delay(100);                                                     // * Ждём десятую долю секунды, чтоб не захламлять stdout.
  }
}                                                                   //
                                                                    //
//  ПРИМЕЧАНИЕ:                                                     //
//  В данном скетче три вывода модуля настроены на работу           //
//  в качестве цифровых входов, но если на выводы не подавать       //
//  логические уровни (не подключать их к внешним устройствам), то  //
//  - с вывода 5 будет читаться уровень логического 0;              //
//  - с вывода 6 будет читаться уровень логической  1;              //
//  - с вывода 7 будет читаться уровень либо 0, либо 1;             //
