# Данный пример плавно меняет аналоговый уровень на выводе модуля.
                                        # $ Строки со знаком $ являются необязательными.
from pyiArduinoI2Cexpander import *     #   Подключаем библиотеку для работы с расширителем выводов.
from time import sleep                  #   Импортируем функцию ожидания из модуля времени 
ext = pyiArduinoI2Cexpander(0x08)       #   Объявляем объект ext для работы с функциями модуля pyiArduinoI2Cexpander, указывая адрес модуля на шине I2C.
                                        #   Если объявить объект без указания адреса (pyiArduinoI2Cexpander()), то адрес будет найден автоматически.
val = 2                                 #   Определяем начальное аналоговое значение.
flg = 1                                 #   Определяем флаг приращения аналогового значения (0-убывает, 1-растёт).
                                        #
ext.pinMode(3, OUTPUT, ANALOG)          # $ Конфигурируем вывод 3 на работу в качестве аналогового выхода.
print("Меняем аналоговое значение."     #
      " Нажмите ctrl+c для выхода")     #
while True:                             #   Входим в бесконечный цикл
  sleep(.01)                            #   Чем выше задержка, тем плавнее меняется аналоговый уровень.
  if val <= 2 or flag:                  #   Меняем спад аналогового уровня на рост.
    val *= 1.05                         #   Увеличиваем аналоговое значение
    flag = True                         #   Устанавливаем флаг
  if val >= 4095 or not flag:           #   Меняем рост аналогового уровня на спад.
    val /= 1.05                         #   Уменьшаем аналоговое значение
    flag = False                        #   Сбрасываем флаг
                                        #
  ext.analogWrite(3, val);              #   Устанавливаем на 3 выводе уровень равный значению «val».
                                        #   Допустимые значения - от 0 до 4095.
#  ПРИМЕЧАНИЕ:                          
#  Для проверки работы скетча подключите светодиод к 3 выводу.
#  Модуль имитирует аналоговый сигнал используя ШИМ.
#  Сигнал ШИМ поддерживают только выводы 0,1,2,3.
#  Для выводов 4,5,6,7, установка уровня от 0 до 2047 приведёт к
#  появлению логического 0, а установка уровня от 2048 до 4095 к
#  появлению логической 1.
