# Данный пример позволяет менять частоту ШИМ.
                                        # $ Строки со знаком $ являются необязательными.
                                        #
from pyiArduinoI2Cexpander import *     #   Подключаем библиотеку для работы с расширителем выводов.
from time import sleep                  # 
ext = pyiArduinoI2Cexpander(0x08)       #   Объявляем объект ext для работы с функциями модуля pyiArduinoI2Cexpander, указывая адрес модуля на шине I2C.
                                        #   Если объявить объект без указания адреса (pyiArduinoI2Cexpander()), то адрес будет найден автоматически.
ext.pinMode(0, OUTPUT, ANALOG)          # $ Конфигурируем вывод 0 на работу в качестве аналогового выхода.
ext.pinMode(1, OUTPUT, ANALOG)          # $ Конфигурируем вывод 1 на работу в качестве аналогового выхода.
ext.pinMode(2, OUTPUT, ANALOG)          # $ Конфигурируем вывод 2 на работу в качестве аналогового выхода.
#Устанавливаем аналоговые уровни:       #
ext.analogWrite(0, 1023)                #   Устанавливаем на 0 выводе уровень равный 1/4 от максимума.
ext.analogWrite(1, 2047)                #   Устанавливаем на 1 выводе уровень равный 2/4 от максимума.
ext.analogWrite(2, 3061)                #   Устанавливаем на 2 выводе уровень равный 3/4 от максимума.
print("Меняем частоту ШИМ. "            # 
      "Нажмите ctrl+c для выхода")      #
while True:                             # 
  ext.freqPWM(10)                       #   Устанавливаем частоту ШИМ в значение 10 Гц.
  sleep(2)                              #   Ждём джве секунды.
  ext.freqPWM(100)                      #   Устанавливаем частоту ШИМ в значение 100 Гц.
  sleep(2)                              #   Ждём две секунды.
  ext.freqPWM(1000)                     #   Устанавливаем частоту ШИМ в значение 1000 Гц (1кГц).
  sleep(2)                              #   Ждём две секунды.
  ext.freqPWM(10000)                    #   Устанавливаем частоту ШИМ в значение 10000 Гц (10кГц).
  sleep(2)                              #   Ждём две секунды.
                                        #
#  ПРИМЕЧАНИЕ:
#  Для проверки работы скетча подключите к выводам светодиоды.
#  Частота ШИМ задаётся для всех выводов поддерживающих ШИМ.
#  При частотах ШИМ ниже 50 Гц заметно мерцание светодиодов и чем
#  ниже частота ШИМ тем сильнее заметно мерцание.
#  Яркость свечения светодиодов зависит от установленного уровня
#  функцией analogWrite, а мерцание светодиодов зависит от частоты
#  Обращение к функциям управления сервоприводами меняет частоту
#  ШИМ на значение 50 Гц.
#  Частота ШИМ по умолчанию 490 Гц (без сервоприводов).
#  Частоту ШИМ можно задавать от 1 до 12'000 Гц, но чем она выше,
#  тем менее точно устанавливается аналоговый уровень
#
#  Если на частотах 1 - 500 Гц точность установки аналогового      #
#  уровня в диапазоне от 0 до 4095 принять за ± 0, то ...          # Пример: 0=>0, 1=>1, 2=>2, 3=>3, 4=>4, 5=>5, 6=>6, 7=>7, 8=>8, ...
#  На частотах    501 - 1000 Гц точность +0 -1                     # Пример: 0=>0, 1=>0, 2=>2, 3=>2, 4=>4, 5=>4, 6=>6, 7=>6, 8=>8, ...
#  На частотах   1001 - 3000 Гц точность +0 -3                     # Пример: 0=>0, 1=>0, 2=>0, 3=>0, 4=>4, 5=>4, 6=>4, 7=>4, 8=>8, ...
#  На частотах   3001 - 6000 Гц точность +0 -7                     #
#  На частотах   6001 -12000 Гц точность +0 -15.                   #
