# Данный пример читает логический уровень с аналогового входа.
                                        # $ Строки со знаком $ являются необязательными.
from pyiArduinoI2Cexpander import *     #   Подключаем библиотеку для работы с расширителем выводов.
from time import sleep                  # 
ext = pyiArduinoI2Cexpander(0x08)       #   Объявляем объект ext для работы с функциями модуля pyiArduinoI2Cexpander, указывая адрес модуля на шине I2C.
                                        #   Если объявить объект без указания адреса (ext = pyiArduinoI2Cexpander()), то адрес будет найден автоматически.
ext.pinMode(4, INPUT, ANALOG)           # $ Конфигурируем вывод 4 на работу в качестве аналогового входа.
ext.levelWrite(512)                     #   Устанавливаем аналоговый уровень разделяющий уровень логического 0 от 1.
ext.levelHyst (12)                      # $ Устанавливаем гистерезис аналогового уровня.
                                        #   В данном случае аналоговый сигнал от 512+12 до 4096 будет воспринят как 1.
                                        #                   аналоговый сигнал от 0 до 512-12 будет воспринят как 0.
                                        #                   аналоговый сигнал от 512-12 до 512+12 не изменит логический уровень.
while True:                             # 
  pin4 = ext.levelRead(4)               #   Читаем логический уровень с вывода №4 в переменную «pin4».
  print("Pin_4="+str(pin4)+"\t\t\t"
        " Нажмтие ctrl+c для выхода")   #
  sleep(.1)                             # $ Ждём десятую долю секунды, чтоб не захламлять stdout.
                                        #
#  ПРИМЕЧАНИЕ:                                                     
#  Для проверки работы скетча подключите потенциометр к 4 выводу.  
#  Чтение логического уровня с выводов сконфигурированных как      
#  аналоговые входы, позволяет работать с логикой отличной от 3,3В 
#  В этом примере за логическую 1 принимается сигнал > 0,4125 В.   
