# Данный пример подключает внутренние резисторы к выводам модуля.
                                        # $ Строки со знаком $ являются необязательными.
from pyiArduinoI2Cexpander import *     #   Подключаем библиотеку для работы с расширителем выводов.
from time import sleep                  #
ext = pyiArduinoI2Cexpander(0x08)       #   Объявляем объект ext для работы с функциями модуля pyiArduinoI2Cexpander, указывая адрес модуля на шине I2C.
if not ext.begin():                     #   Если Trema+Expander Hat не найден,
  exit()                                #   выходим из скрипта
ext.pinMode(5, INPUT, DIGITAL)          # $ Конфигурируем вывод 5 на работу в качестве цифрового входа.
ext.pinMode(6, INPUT, DIGITAL)          # $ Конфигурируем вывод 6 на работу в качестве цифрового входа.
ext.pinMode(7, INPUT, DIGITAL)          # $ Конфигурируем вывод 7 на работу в качестве цифрового входа.
ext.pinPull(5, PULL_DOWN)               #   Прижимаем   вывод 5 к  уровню GND через внутренний резистор.
ext.pinPull(6, PULL_UP)                 #   Подтягиваем вывод 6 до уровня VCC через внутренний резистор.
ext.pinPull(7, PULL_NO)                 #   Оставляем   вывод 7 без подключения внутренних резисторов.
                                        #
while True:                             #
    pin5 = ext.digitalRead(5)           #   Читаем логический уровень с вывода №5 в переменную «pin5».
    pin6 = ext.digitalRead(6)           #   Читаем логический уровень с вывода №6 в переменную «pin6».
    pin7 = ext.digitalRead(7)           #   Читаем логический уровень с вывода №7 в переменную «pin7».
    print("p5=" + str(pin5)             #
          + ", p6=" + str(pin6)         #
          + ", p7=" + str(pin7)         #
          , end='')                     #
    print("\t\t\t\t\t\t\t "             #
          "Нажмтие ctrl+c для выхода")  #
    sleep(.1)                           # $ Ждём десятую долю секунды, чтоб не захламлять stdout.
                                        #
#  ПРИМЕЧАНИЕ:
#  В данном скетче три вывода модуля настроены на работу
#  в качестве цифровых входов, но если на выводы не подавать
#  логические уровни (не подключать их к внешним устройствам), то
#  - с вывода 5 будет читаться уровень логического 0
#  - с вывода 6 будет читаться уровень логической  1
#  - с вывода 7 будет читаться уровень либо 0, либо 1
