# Данный пример демонстрирует программную перезагрузку модуля.
                                        # $ Строки со знаком $ являются необязательными.
from pyiArduinoI2Cexpander import *     #   Подключаем модуль для работы с расширителем выводов.
from time import sleep                  #   Импортируем функцию ожидания из модуля времени 
ext = pyiArduinoI2Cexpander(0x08)       #   Объявляем объект ext для работы с функциями модуля pyiArduinoI2Cexpander, указывая адрес модуля на шине I2C.
                                        #
ext.pinMode(3, OUTPUT, ANALOG)          # $ Конфигурируем вывод 3 на работу в качестве аналогового выхода.
ext.analogWrite(3, 2047)                #   Устанавливаем на 3 выводе уровень равный половине от максимума.
sleep(2)                                #   Ждём две секунды.
ext.reset()                             #   Перезагружаем модуль.
                                        #
#  ПРИМЕЧАНИЕ:                                                     
#  Для проверки работы скетча подключите светодиод к 3 выводу.     
#  Сконфигурировав вывод №3 в режим аналогового выхода и подав на  
#  него аналоговый уровень, светодиод включится. Но через две сек. 
#  после его включения произойдёт перезагрузка модуля и все выводы 
#  переконфигурируются в значение по умолчанию (цифровые входы),   
#  что приведёт к исчезновению аналогового уровня с вывода №3 и,   
#  как следствие, отключению светодиода.                           
