# Данный пример позволяет устанавливать угол сервопривода.
                                        # $ Строки со знаком $ являются необязательными.
from pyiArduinoI2Cexpander import *     #   Подключаем библиотеку для работы с расширителем выводов.
from time import sleep                  # 
ext = pyiArduinoI2Cexpander(0x08)       #   Объявляем объект ext для работы с функциями модуля pyiArduinoI2Cexpander, указывая адрес модуля на шине I2C.
                                        #
ext.pinMode(3, OUTPUT, SERVO)           # $ Конфигурируем вывод 3 на работу в качестве выхода для сервопривода.
print("Управляем сервоприводом. "
      "Нажмите ctrl+c для выхода.")     #
while True:                             # 
  ext.servoWrite(3, 0)                  #   Поворачиваем сервопривод в угол 0°.
  sleep(.5)                             #   Ждём пол секунды.
  ext.servoWrite(3, 90)                 #   Поворачиваем сервопривод в угол 90°.
  sleep(.5)                             #   Ждём пол секунды.
  ext.servoWrite(3, 180)                #   Поворачиваем сервопривод в угол 180°.
  sleep(.5)                             #   Ждём пол секунды.
                                        #
#  ПРИМЕЧАНИЕ:                          
#  Для проверки работы скетча подключите сервопривод к 3 выводу.   
#  По умолчанию библиотека работает с сервоприводами у которых     
#  угол поворота равен 180°. Для работы с другими сервоприводами   
#  задайте их параметры используя функцию servoAttach().           
#  Управление сервоприводами осуществляется с помощью сигнала ШИМ. 
#  Обращение к функции servoWrite() приводит к смене частоты ШИМ   
#  в значение 50 Гц на всех выводах поддерживающих ШИМ: 0,1,2,3.   
#  Значит если сконфигурировать любой другой вывод, поддерживающий 
#  ШИМ, на работу в качестве аналогового выхода, его сигнал так же 
#  снизится до 50 Гц.                                              
