# Данный пример позволяет устанавливать угол сервопривода.
                                        # $ Строки со знаком $ являются необязательными.
                                        #
from pyiArduinoI2Cexpander import *     #   Подключаем библиотеку для работы с расширителем выводов.
from time import sleep                  # 
ext = pyiArduinoI2Cexpander(0x08)       #   Объявляем объект ext для работы с функциями модуля pyiArduinoI2Cexpander, указывая адрес модуля на шине I2C.
                                        # 
ext.pinMode(3, OUTPUT, SERVO)           # $ Конфигурируем вывод 3 на работу в качестве выхода для сервопривода.
                                        #
while True:                             # 
  ext.servoWriteMicroseconds(3, 500)    #   Подаём на сервопривод ШИМ с длительностью импульсов 500 мкс.
  sleep(.5)                             #   Ждём пол секунды.
  ext.servoWriteMicroseconds(3, 1500)   #   Подаём на сервопривод ШИМ с длительностью импульсов 1500 мкс.
  sleep(.5)                             #   Ждём пол секунды.
  ext.servoWriteMicroseconds(3, 2500)   #   Подаём на сервопривод ШИМ с длительностью импульсов 2500 мкс.
  sleep(.5)                             #   Ждём полсекунды.
                                        #
#  ПРИМЕЧАНИЕ:                          
#  Для проверки работы скетча подключите сервопривод к 3 выводу.  
#  Угол поворота сервоприводов зависит от длительности импульсов  
#  подаваемого сигнала ШИМ. У большинства сервоприводов угол в 0° 
#  соответствует длительности импульсов 500 мкс, а угол в 180°    
#  соответствует длительности импульсов 2500 мкс.                 
#  Если Вы не знаете соотношение длительности импульсов к углу    
#  поворота Вашего сервопривода, функция servoWriteMicroseconds() 
#  поможет Вам его найти, перебором значений длительностей.       
#  Обращение к функции servoWriteMicroseconds() устанавливает     
#  частоту ШИМ в 50 Гц на всех выводах поддерживающих ШИМ: 0,1,2,3
#  Значит если сконфигурировать любой другой вывод, поддерживающий
#  ШИМ, на работу в качестве аналогового выхода, его сигнал так же
#  снизится до 50 Гц.                                             
